# Apocalypse
# Made by GatKong

#enable sniper skeletons
#execute as @e[tag=sniper] at @s run data merge entity @e[limit=1,sort=nearest,type=arrow] {NoGravity:1b}

#tag entities
#execute as @e run execute unless entity @s[scores={mob=0..}] run function gatkong:z000

scoreboard players set @a[scores={gatA_zombie=1..}] gatA_turned 1
scoreboard players set @a[scores={gatA_zvillager=1..}] gatA_turned 1
scoreboard players set @a[scores={gatA_drowned=1..}] gatA_turned 1

execute as @a[scores={gatA_died=1..}] at @s run function gatkong:z023players

#allow removal with bonemeal
execute as @e[tag=deathmarker] at @s if entity @e[type=minecraft:item,distance=0.01..0.8,nbt={Item:{id:"minecraft:bone_meal"}}] run kill @s

#settle markers to solid ground
execute as @e[tag=newmarker,limit=1] at @s if block ~ ~-1 ~ #gatkong:crushable run setblock ~ ~ ~ minecraft:air replace
execute as @e[tag=newmarker,limit=1] at @s if block ~ ~-1 ~ #gatkong:crushable run setblock ~ ~-1 ~ minecraft:stone_brick_slab replace
execute as @e[tag=newmarker,limit=1] at @s if block ~ ~-1 ~ minecraft:stone_brick_slab run tp @s ~ ~-1 ~

#rescue markers from the void
execute as @e[tag=newmarker,limit=1] at @s if block ~ 0 ~ minecraft:stone_brick_slab run tag @s add changemarker
execute as @e[tag=newmarker,limit=1] at @s if block ~ 0 ~ minecraft:stone_brick_slab run tag @s remove newmarker

#solidify stable markers
execute as @e[tag=newmarker] at @s unless block ~ ~-1 ~ #gatkong:crushable run tag @s add changemarker
execute as @e[tag=newmarker] at @s unless block ~ ~-1 ~ #gatkong:crushable run tag @s remove newmarker

#finalize stable markers
execute as @e[tag=changemarker,nbt={Dimension:0}] at @s run setblock ~ ~ ~ minecraft:stone_brick_stairs[facing=south,half=bottom,shape=straight,waterlogged=false] replace
execute as @e[tag=changemarker,nbt={Dimension:0}] at @s unless block ~ ~-1 ~-1 #gatkong:crushable run setblock ~ ~ ~-1 minecraft:potted_allium keep

execute as @e[tag=changemarker,nbt={Dimension:-1}] run replaceitem entity @s weapon.mainhand minecraft:golden_sword 1
execute as @e[tag=changemarker,nbt={Dimension:-1}] at @s run setblock ~ ~ ~ minecraft:quartz_stairs[facing=south,half=bottom,shape=straight,waterlogged=false] replace
execute as @e[tag=changemarker,nbt={Dimension:-1}] at @s unless block ~ ~-1 ~-1 #gatkong:crushable run setblock ~ ~ ~-1 minecraft:potted_blue_orchid keep

execute as @e[tag=changemarker,nbt={Dimension:1}] run replaceitem entity @s weapon.mainhand minecraft:diamond_sword 1
execute as @e[tag=changemarker,nbt={Dimension:1}] at @s run setblock ~ ~ ~ minecraft:purpur_stairs[facing=south,half=bottom,shape=straight,waterlogged=false] replace
execute as @e[tag=changemarker,nbt={Dimension:1}] at @s unless block ~ ~-1 ~-1 #gatkong:crushable run setblock ~ ~ ~-1 minecraft:potted_white_tulip keep

execute as @e[tag=changemarker] at @s run tag @s add deathmarker
execute as @e[tag=changemarker] at @s run tag @s remove changemarker

#zombiepigman protect the netherquartz

execute at @a[scores={gat_quartz=1..}] run execute at @e[type=zombie_pigman,distance=..32,sort=nearest,limit=1,nbt={Anger:0s}] run playsound minecraft:entity.zombie_pigman.hurt hostile @a ~ ~ ~

execute at @a[scores={gat_quartz=1..}] run data merge entity @e[type=zombie_pigman,distance=..32,sort=nearest,limit=1,nbt={Anger:0s}] {Anger:600}

scoreboard players remove @a[scores={gat_quartz=1..}] gat_quartz 1

#skeletons
execute as @e[type=#gatkong:skeletons] unless entity @s[tag=skeleton] run function gatkong:z023skeleton

#witches
execute as @e[type=witch] unless entity @s[tag=witch] run function gatkong:z023witch

#monitor spider spinning
execute as @e[sort=random,limit=1] run scoreboard players add @s[type=spider] gatA_spinneret 1
execute as @e[sort=random,limit=1] run execute as @s[type=spider,scores={gatA_spinneret=40..}] run function gatkong:z023spider

#bats bite
execute as @e[type=bat,nbt={BatFlags:0b}] at @s run effect give @p[distance=..1.5] minecraft:instant_damage

#monitor bat morphing
execute as @e[sort=random,limit=1] run scoreboard players add @s[type=bat] gatA_spinneret 1
execute as @e[sort=random,limit=1] at @s run execute as @s[type=bat,scores={gatA_spinneret=20..},nbt={BatFlags:0b}] run function gatkong:z023bat

# Oxhead

### limit to only one
scoreboard players reset @e[tag=oxhead] gat_near
execute as @e[tag=oxhead] run scoreboard players add @e[tag=oxhead] gat_near 1
kill @e[tag=oxhead,tag=!minotaur,limit=1,scores={gat_near=2..}]

execute unless entity @e[tag=oxStand] run summon armor_stand ~ ~ ~ {Invulnerable:1b,NoGravity:1,Invisible:1b,NoBasePlate:1,Tags:["oxStand"]}

execute as @e[type=armor_stand,tag=oxStand,limit=1] at @s unless entity @e[tag=oxhead] run playsound entity.zombie_horse.death hostile @a ~ ~ ~ 1 0.5

scoreboard players add @e[tag=oxhead,limit=1] gat_ox 1

execute at @e[tag=oxhead,scores={gat_ox=200},limit=1] run playsound entity.cow.ambient hostile @a ~ ~ ~ 1 0.5

execute at @e[tag=oxhead,scores={gat_ox=399},limit=1] run playsound entity.horse.ambient hostile @a ~ ~ ~ 1 0.5

scoreboard players set @e[tag=oxhead,scores={gat_ox=400..},limit=1] gat_ox 0

execute unless entity @e[tag=oxhead] run function gatkong:z023oxhead

tp @e[type=armor_stand,tag=oxStand,limit=1] ~ ~254 ~
tp @e[type=armor_stand,tag=oxStand,limit=1] @e[tag=oxhead,limit=1]
tp @e[type=armor_stand,tag=oxStand,limit=1] @e[tag=minotaur,limit=1]

# Halfdan

### limit to only one
#scoreboard players reset @e[tag=halfdan] gat_near
#execute as @e[tag=halfdan] run scoreboard players add @e[tag=halfdan] gat_near 1
#kill @e[tag=halfdan,limit=1,scores={gat_near=2..}]
#execute unless entity @e[tag=halfdan] run function gatkong:z023halfdan

# Herobrine

### limit to only one
scoreboard players reset @e[tag=herobrine] gat_near
execute as @e[tag=herobrine] run scoreboard players add @e[tag=herobrine] gat_near 1
kill @e[tag=herobrine,limit=1,scores={gat_near=2..}]

scoreboard players reset @e[tag=brineStand] gat_near
execute as @e[tag=brineStand] run scoreboard players add @e[tag=brineStand] gat_near 1
kill @e[tag=brineStand,limit=1,scores={gat_near=2..}]

execute unless entity @e[tag=brineStand] run summon armor_stand ~ ~ ~ {Invulnerable:1b,NoGravity:1,Invisible:1b,NoBasePlate:1,Tags:["brineStand"]}

execute as @e[type=armor_stand,tag=brineStand,limit=1] at @s unless entity @e[tag=herobrine] run playsound entity.illusioner.cast_spell hostile @a ~ ~ ~ 1

scoreboard players add @e[tag=herobrine,limit=1] gat_brine 1

execute at @e[tag=herobrine,scores={gat_brine=1},limit=1] run playsound minecraft:music_disc.11 hostile @a ~ ~ ~ 0.25

execute at @e[tag=herobrine,scores={gat_brine=1025},limit=1] run stopsound @a hostile minecraft:music_disc.11

scoreboard players set @e[tag=herobrine,scores={gat_brine=1500..},limit=1] gat_brine 0

execute unless entity @e[tag=herobrine] run function gatkong:z023herobrine

tp @e[type=armor_stand,tag=brineStand,limit=1] ~ ~254 ~
tp @e[type=armor_stand,tag=brineStand,limit=1] @e[tag=herobrine,limit=1]

## The Litch

### limit to only one
scoreboard players reset @e[tag=litch] gat_near
execute as @e[tag=litch] run scoreboard players add @e[tag=litch] gat_near 1
kill @e[tag=litch,limit=1,scores={gat_near=2..}]

execute unless entity @e[tag=litch] run function gatkong:z023litch

scoreboard players add @e[tag=litch] gat_litch 1

execute as @e[tag=litch,scores={gat_litch=53000..},limit=1] at @s run playsound minecraft:entity.illusioner.mirror_move hostile @a
execute as @e[tag=litch,scores={gat_litch=53000..},limit=1] at @s run particle minecraft:enchant ~ ~1 ~ 1 1 1 0.01 100 force
execute as @e[tag=litch,scores={gat_litch=53000..},limit=1] at @s run particle minecraft:squid_ink ~ ~1 ~ 1 1 1 0.01 20 force

execute at @p run tp @e[tag=litch,scores={gat_litch=53000..},limit=1] @e[type=#skeletons,sort=random,limit=1]

execute as @e[tag=litch,scores={gat_litch=53000..},limit=1] at @s run playsound minecraft:entity.illusioner.mirror_move hostile @a
execute as @e[tag=litch,scores={gat_litch=53000..},limit=1] at @s run particle minecraft:lava ~ ~1 ~ 1 1 1 0.01 50 force
execute as @e[tag=litch,scores={gat_litch=53000..},limit=1] at @s run particle minecraft:witch ~ ~1 ~ 1 1 1 0.01 100 force

scoreboard players set @e[tag=litch,scores={gat_litch=53000..},limit=1] gat_litch 0

execute as @e[tag=litch] at @s run kill @e[type=#gatkong:alive,distance=..1]

scoreboard players add @e[tag=litch] gat_litchtaunt 1

execute as @e[tag=litch,scores={gat_litchtaunt=72000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"the Litch whispers to you: I am the end, and I have come for you, ","color":"gray","italic":true},{"selector":"@p[nbt={Dimension:0}]","color":"gray","italic":true},{"text":".","color":"gray","italic":true}]
execute as @e[tag=litch,scores={gat_litchtaunt=72000},limit=1] at @p[nbt={Dimension:0}] run particle minecraft:enchant ^ ^2 ^ 1 1 1 0.01 100 force

execute as @e[tag=litch,scores={gat_litchtaunt=144000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"the Litch whispers to you: There is only darkness for you, ","color":"gray","italic":true},{"selector":"@p[nbt={Dimension:0}]","color":"gray","italic":true},{"text":".","color":"gray","italic":true}]
execute as @e[tag=litch,scores={gat_litchtaunt=144000},limit=1] at @p[nbt={Dimension:0}] run particle minecraft:enchant ^ ^2 ^ 1 1 1 0.01 100 force
execute as @e[tag=litch,scores={gat_litchtaunt=144000},limit=1] at @a[nbt={Dimension:0}] run playsound minecraft:entity.illusioner.cast_spell hostile @a ~ ~ ~

execute as @e[tag=litch,scores={gat_litchtaunt=216000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"the Litch whispers to you: You, ","color":"gray","italic":true},{"selector":"@p[nbt={Dimension:0}]","color":"gray","italic":true},{"text":", will die, over and over. Mountains of broken bodies beneath the wheel.","color":"gray","italic":true}]

execute as @e[tag=litch,scores={gat_litchtaunt=288000},limit=1] run tellraw @a[nbt={Dimension:0}] ["",{"text":"["},{"text":"the Litch","color":"gold"},{"text":"] I am the ceaseless wheel. The last Scholar of GOLB. I am "},{"selector":"@p[nbt={Dimension:0}]"},{"text":"'s doom."}]

execute as @e[tag=litch,scores={gat_litchtaunt=360000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"the Litch whispers to you: ","color":"gray","italic":true},{"selector":"@p[nbt={Dimension:0}]","color":"gray","italic":true},{"text":", and now for your education. Before there was time, before there was anything, there was nothing. And before there was nothing, there were monsters.","color":"gray","italic":true}]

execute as @e[tag=litch,scores={gat_litchtaunt=432000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"the Litch whispers to you: There is only darkness for you, ","color":"gray","italic":true},{"selector":"@p[nbt={Dimension:0}]","color":"gray","italic":true},{"text":", and only the void for your people.","color":"gray","italic":true}]
execute as @e[tag=litch,scores={gat_litchtaunt=432000},limit=1] at @p[nbt={Dimension:0}] run playsound minecraft:entity.illusioner.cast_spell hostile @a ~ ~ ~

execute as @e[tag=litch,scores={gat_litchtaunt=504000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"the Litch whispers to you: Aren't you cold, ","color":"gray","italic":true},{"selector":"@p[nbt={Dimension:0}]","color":"gray","italic":true},{"text":"?","color":"gray","italic":true}]
execute as @e[tag=litch,scores={gat_litchtaunt=504000},limit=1] at @p[nbt={Dimension:0}] run particle minecraft:enchant ^ ^2 ^ 1 1 1 0.01 100 force

execute as @e[tag=litch,scores={gat_litchtaunt=576000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"["},{"text":"the Litch","color":"gold"},{"text":"] "},{"selector":"@p[nbt={Dimension:0}]"},{"text":", I have seen the dark universe yawning Where the black planets roll without aim, Where they roll in their horror unheeded, Without knowledge, or lustre, or name."}]

execute as @e[tag=litch,scores={gat_litchtaunt=648000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"the Litch whispers to you: ","color":"gray","italic":true},{"selector":"@p[nbt={Dimension:0}]","color":"gray","italic":true},{"text":", I have haunted the tombs of the ages, I fly on the pinions of your fear.","color":"gray","italic":true}]

execute as @e[tag=litch,scores={gat_litchtaunt=720000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"the Litch whispers to you: You are alone, ","color":"gray","italic":true},{"selector":"@p[nbt={Dimension:0}]","color":"gray","italic":true}, {"text":". No one can save you.","color":"gray","italic":true}]
execute as @e[tag=litch,scores={gat_litchtaunt=720000},limit=1] at @p[nbt={Dimension:0}] run particle minecraft:enchant ^ ^2 ^ 1 1 1 0.01 100 force

execute as @e[tag=litch,scores={gat_litchtaunt=792000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"["},{"text":"the Litch","color":"gold"},{"text":"] I was old in those epochs uncounted When I, and I only, was vile; And Man, yet untainted and happy, dwelt in bliss on the far Overworld isle."}]

execute as @e[tag=litch,scores={gat_litchtaunt=864000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"["},{"text":"the Litch","color":"gold"},{"text":"] And great is the reach of my doom; Nor can respite be found in the tomb: Down the infinite aeons come beating the wings of unmerciful gloom."}]

execute as @e[tag=litch,scores={gat_litchtaunt=936000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"the Litch whispers to you: You are strong, ","color":"gray","italic":true},{"selector":"@p[nbt={Dimension:0}]","color":"gray","italic":true}, {"text":", but I am beyond strength.","color":"gray","italic":true}]
execute as @e[tag=litch,scores={gat_litchtaunt=936000},limit=1] at @p[nbt={Dimension:0}] run particle minecraft:enchant ^ ^2 ^ 1 1 1 0.01 100 force

execute as @e[tag=litch,scores={gat_litchtaunt=1008000},limit=1] run tellraw @p[nbt={Dimension:0}] ["",{"text":"["},{"text":"the Litch","color":"gold"},{"text":"] I have liv’d o’er my lives without number, I have sounded all things with my sight."}]

scoreboard players set @e[tag=litch,scores={gat_litchtaunt=1008000..},limit=1] gat_litchtaunt 0

#Mine that craft!
execute at @a[nbt={SelectedItem:{tag:{display:{Lore:['{"text":"BrineCraft"}']}}}}] run function gatkong:z023vein

execute at @a[nbt={SelectedItem:{tag:{display:{Lore:['{"text":"LitchCraft"}']}}}}] run function gatkong:z023vein

function gatkong:z010

######### WIP LINE #########

#tellraw @a ["",{"text":"z023 Apocalypse","color":"blue"}]


##For coal, diamond, emerald, nether quartz, and lapis lazuli, level I gives a 33% chance to multiply drops by 2 (averaging 33% increase), level II gives a chance to multiply drops by 2 or 3 (25% chance each, averaging 75% increase), and level III gives a chance to multiply drops by 2, 3, or 4 (20% chance each, averaging 120% increase).

#type=#skeletons

########### zombie kills need to merge data so gets the name and stuff

#data modify entity @e[type=zombie,limit=1] CustomName set value "{\"text\":\"Jill\"}"

#data modify entity @e[type=zombie,limit=1] CustomName set value "{\"text\":\"\",\"selector\":\"@p\"}"

#data modify entity @e[type=zombie,limit=1] CustomName set value "{\"text\":\"selector\":\"@p\"}"

#This works to change name to Jack
#data modify entity @e[type=zombie,limit=1] CustomName set value "{\"text\":\"Jack\",\"selector\":\"@p\"}"

#execute as GatKong run data modify entity @e[type=zombie,limit=1] CustomName set value "{\"text\":\"Zombie\",\"selector\":\"@s\"}"

#data modify entity @e[type=zombie,limit=1] {} merge from entity @s {}

#data modify entity @e[type=zombie,limit=1,sort=nearest] HandItems set from entity @s HandItems

#data modify entity @e[sort=nearest,limit=1,tag=BlueClone] ArmorItems set from entity @s ArmorItems

#data merge entity @e[type=husk,limit=1,sort=nearest] {CustomName:"{\"text\":\"Test\"}"}

#{CustomName:"{\"text\":\"Test\"}"}

#data modify entity @e[type=vindicator,limit=1] CustomName set from entity @e[type=zombie,limit=1] CustomName

#execute at @e[type=vindicator,limit=1,sort=nearest] run data modify entity @e[type=vindicator,limit=1,sort=nearest] Entity.CustomName set from entity @p Entity.tag.Name

#execute at @e[type=vindicator,limit=1,sort=nearest] run data modify entity @e[type=vindicator,limit=1,sort=nearest] Entity.CustomName set from value {CustomName:"{\"text\":\"Test\"}"}